<?php

    session_start();

    // ====== Load Functions Libraries ======
    $site_root = "..";
    $xable_admin = "xable/admin";
    //$xable_admin = "../admin";

    require "$xable_admin/repository/functions.php";
    require "$xable_admin/repository/cms.php";
    require "$xable_admin/repository/xml.php";

?>

<!doctype html>
<html lang='en'>
	<head>
		<meta charset="UTF-8">
		<title>X.able CMS / Xable Jable</title>
		<link href='http://fonts.googleapis.com/css?family=Lato:100,300,400,700,900|Inconsolata:400,700|Audiowide&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
        <link rel="stylesheet" type="text/css" href="<?php echo "$xable_admin/_tools/_tools.css" ?>" />
        <style></style>
    </head>
    <body>
        <button class='close' onclick="self.close()">X</button>
        
<?php
    
    function contentlinkFixes($xml) {
    // Edit _category, _conections links etc.
        foreach(array_keys($xml) as $article_name) {
            $article_group = $xml[$article_name];
            if(substr($article_name, 0, 1) != "_") {
                foreach(array_keys($article_group) as $article_num) {
                    $article = $article_group[$article_num];
                    foreach(array_keys($article) as $section_name) {
                        if(substr($section_name, 0, 1) == "_" || $section_name == "path") {
                            $section = $article[$section_name][0];
                            //arrayList($section);
                            foreach(array_keys($section) as $tag) {
                                $val = $section[$tag][0];
                                if(array_pop(explode(".", $val)) == "xml") {
                                    $val = str_replace("xml", "json", $val);
                                    echo "Edit: [$article_name-$article_num-$section_name-0-$tag-0]: \"$val\"<br>\n";
                                    $xml[$article_name][$article_num][$section_name][0][$tag][0] = $val;
                                }
                            }
                        }
                    }
                }
            }
        };
        return $xml;
    };
    
    function xmlToJson($path, $backup_folder) {
    // Load XML, convert to JSON
        $xml = join(" ", array_map("trim", file($path)));
        $xml = xmlToArray($xml);
        if(is_array($xml)) {
            if(array_shift(array_keys($xml)) == "xable") { $xml = $xml['xable'][0]; };
            $xml = contentlinkFixes($xml);
            $json = arrayToJson($xml);
            if($json && json_decode($json)) {
                $dir = path($path, "dirname");
                if($dir && $dir != "") { $dir = $dir."/"; };
                $new_path = $dir.str_replace(".xml", ".json", path($path, "basename"));
                backupSave($path, $new_path, $json, $backup_folder);
                //echo "<textarea style='width:100%;height:auto'>".$json."</textarea><br>\n";
            }
            else {
                echo "#ERROR! Conversion to JSON failed: $path<br>\n";
            }
        }
        else {
            echo "#ERROR! Not valid XML: $path<br>\n";
        }
    };
              
    function backupSave($path, $new_path, $content, $backup_folder) {
    // Move original file to backup folder and save the new one
        $bak_path = $backup_folder."/".str_replace("/", "%", $path);
        if(is_string($content) && $content != "") {
            rename($path, $bak_path);
            file_put_contents($new_path, $content);
            echo "Move: $path -> $bak_path | Save content to: $new_path<br>\n";
        }
        else {
            rename($path, $bak_path);
            copy($new_path, $path);
            echo "Move: $path -> $bak_path | Copy $new_path -> $path<br>\n";
        }
    }

    echo "<h1>Xable Jable 4to5 converter</h1><hr>\n";
    if(isset($_POST["action"]) && $_POST["action"] == "json") {
        
        $backup_folder = "$site_root/tmp/xable-jable";
        
        echo "<b>XML -> JSON</b><hr>\n";
        makeDir($backup_folder);
        $xable_ext = [ "draft", "prev", "xml", "order", "template" ];
        foreach(listDir("$site_root", ".,?") as $path) {
            $ext = path($path, "extension");
            if(in_array($ext, $xable_ext) && path($path, "filename") != "browserconfig") {
                $json = xmlToJson($path, $backup_folder);
            }
        }
        foreach(filesTree("$site_root/pages", ".") as $path) {
            $ext = path($path, "extension");
            if(in_array($ext, $xable_ext)) {
                $json = xmlToJson($path, $backup_folder);
            }
        }
        
        echo "<hr><b>Edit INI files</b><hr>\n";
        $ini_pathes = array_merge([ "$site_root/admin/xable.ini" ], listDir("$site_root/admin/_users", "ini,?"));
        foreach($ini_pathes as $path) {
            //echo "[$path]<br>\n";
            $content = array_map("trim", explode("\n", file_get_contents($path)));
            //echo "<textarea>".join("\n", $ini)."</textarea><br>\n";
            foreach(array_keys($content) as $i) {
                $text = $content[$i];
                if(strstr($text, "=") && strstr($text, ".xml")) {
                    $text = str_replace(".xml", ".json", $text);
                    $content[$i] = $text;
                    //echo "> $text<br>\n";
                }
            }
            backupSave($path, $path, join("\n", $content), $backup_folder);
        }

        echo "<hr><b>Update launcher.php</b><hr>\n";
        $path = "$site_root/modules/launcher.php";
        if(file_exists($path)) {
            $content = array_map("trim", explode("\n", file_get_contents($path)));
            foreach(array_keys($content) as $i) {
                $text = $content[$i];
                if(strstr($text, ".xml\"")) {
                    $text = str_replace(".xml\"", ".json\"", $text);
                    $content[$i] = $text;
                    //echo "> $text<br>\n";
                }
            }
            backupSave($path, $path, join("\n", $content), $backup_folder);
        };
        
        echo "<hr><b>Update xml.php</b><hr>\n";
        $new_file = "$xable_admin/repository/xml.php";
        $old_file = "$site_root/script/xml.php";
        rename($old_file, "$old_file.bak");
        copy($new_file, $old_file);
        echo "Updated: $new_file -> $old_file<br>\n";
        
        echo "<hr><b>Reset SITEMAP</b><hr>\n";
        $sitemap = "$site_root/sitemap.json";
        if(file_exists($sitemap)) {
            $sitemap_bak = $backup_folder."/".str_replace("/", "%", $sitemap);
            rename($sitemap, $sitemap_bak);
            echo "Delete: $sitemap<br>\n";
        };
        
        echo "<hr><b>Reset CATEGORIES plugin data</b><hr>\n";
        $categories = "$site_root/admin/_plugins/categories/categories_map.json";
        if(file_exists($categories)) {
            $categories_bak = $backup_folder."/".str_replace("/", "%", $categories);
            rename($categories, $categories_bak);
            echo "Delete: $categories<br>\n";
        };
        
        echo "<hr><b>Update COOKIES plugins</b><hr>\n";
        $site_plugin = "/_plugins/cookies-alert";
        $admin_plugin = "admin/_plugins/cookies_button";
        if(file_exists("$site_root/$site_plugin") && file_exists("$xable_admin/../$site_plugin")) {
            $xml = loadXml("$site_root/$site_plugin/cookies-alert.json");
            $json = arrayToJson($xml);
            //removeDir("$site_root/$site_plugin");
            //removeDir("$site_root/$admin_plugin");
        };
        
        if(file_exists("$site_root/$site_plugin") && file_exists("$xable_admin/../$site_plugin")) {
            echo "<hr><b>Update COOKIES plugins</b><hr>\n";
            $path = "$site_root/$site_plugin/cookies-alert";
            $xml = loadXml("$path.xml");
            if($json = arrayToJson($xml)) {
                //echo "backup: $backup_folder/$site_plugin<br>\n";
                moveDir("$site_root/$site_plugin", "$backup_folder/$site_plugin");
                copyDir("xable/$site_plugin", "$site_root/$site_plugin");
                echo "Copy: xable/$site_plugin -> $site_root/$site_plugin<br>\n";
                echo "Updated: $site_plugin<br>\n";
                
                moveDir("$site_root/admin/$admin_plugin", "$backup_folder/admin/$admin_plugin");
                copyDir("$xable_admin/$admin_plugin", "$site_root/admin/$admin_plugin");
                echo "Updated: $admin_plugin<br>\n";
                
                file_put_contents("$path.json", $json);
                echo "Updated: $path.xml -> $path.json<br>\n";
                unlink("$path.xml");
            }
        };
        
        // ====== DONE ======
        
        echo "<hr><hr><hr><b>DONE!<br>Close this window & continue to install X.able 5+</b><hr>\n";

    }
    else {
        echo "<form method='post'>\n";
        echo "<p>Convert site content from XML to JSON format:</p>\n";
        echo "<button name='action' value='json' type='submit'>Start</button>\n";
        echo "</form>\n";
    };

?> 
        
    </body>
</html>