<?php
    session_start();
    $admin_root = "..";
    $site_root = "../..";
    $path = "$admin_root/localization";

    // ====== Load Functions Libraries ======

    require "$admin_root/repository/functions.php";
    require "$admin_root/repository/cms.php";
    require "$admin_root/repository/xml.php";
    $login = "$admin_root/login.php";
    require "$admin_root/modules/_security.php";
?>

<!doctype html>
<html lang='<?php echo $_SESSION["admin_lang"]; ?>'>
	<head>
		<meta charset="UTF-8">
		<title>Localization editor</title>
        
		<link href='http://fonts.googleapis.com/css?family=Lato:100,300,400,700,900|Inconsolata:400,700|Audiowide&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
        <link rel="stylesheet" type="text/css" href="../style/foundation-icons.css" />
        <link rel="stylesheet" type="text/css" href="localization_editor.css<?php echo "?v=".uniqid(); ?>" />
        
        <script src="../repository/jquery-3.5.1.min.js"></script>
        <script src="../repository/jquery-ui.min.js"></script>
        <script src="../repository/jquery.ui.touch-punch.min.js"></script>
        <script src="../repository/functions.js<?php echo "?v=".uniqid(); ?>"></script>
        
        <style> #loader { position: fixed; top: 0; left: 0; width: 100%; height: 100%; background-color: #eee; z-index: 9999; } </style>
    </head>
    <body>
        <div id='loader'></div>
<?php
 
    if($_GET["action"] == "save" && count($_POST) > 0) {
        foreach(array_keys($_POST) as $key) {
            if(substr($key, 0, 5) == "json|") {
                $language = array_pop(explode("|", $key));
                $json = $_POST[$key];
                if(safeSave("$path/$language.json", $json)) {
                    echo "<!-- Saved: \"$path/$language.json\" -->\n";
                }
            }
        }
    }

    //echo "<h1>Localization editor</h1><hr>\n";
    $files_list = listDir($path, "json");

    echo "<script>\n";
    echo "\tvar LOCALIZATIONS = {};\n";
    foreach($files_list as $file) {
        $json = file_get_contents("$path/$file");
        $language = path($file, "filename");
        echo "\tLOCALIZATIONS[\"$language\"] = $json;\n";
    }
    echo "</script>\n";
    //arrayList($localization);
              
    echo "<div id='files_list'>\n";
    echo "\t<dl>\n";
    echo "\t\t<dt>Folder</dt>\n";
    //foreach($files_list as $file) {
    //    $filename = path($file, "filename");
    //    echo "\t\t<dd>".$filename."</dd>\n";
    //}
    echo "\t</dl>\n";
    echo "</div>\n";

    echo "<div id='keys_list'>\n";
    echo "\t<dl>\n";
    echo "\t\t<dt>Key</dt>\n";
    echo "\t</dl>\n";
    echo "</div>\n";
        
    echo "<div id='editor'>\n";
    echo "\t<dl>\n";
    echo "\t\t<dt>Translation</dt>\n";
    $settings = loadXml("$site_root/settings.json", "draft");
    foreach($settings["multi_language"] as $language) {
        $language = $language["id"][0]["string"][0];
        echo "\t\t<dd class='edit lang-$language' data-lang='$language'>\n";
        echo "\t\t\t<label>$language</label>\n";
        echo "\t\t\t<textarea></textarea>\n";
        echo "\t\t</dd>\n";
    }
    echo "\t</dl>\n";
    echo "</div>\n";
?> 
        <form id='output' method='post' action='?action=save'>
            <textarea class='loaded' placeholder='loaded'></textarea>
        </form>
        
        <header>
            <h1>Localization editor</h1>
            <form id='search'>
                <input type='text'>
                <button class='fi-magnifying-glass'></button>
            </form>
            <nav>
                <button class='save'>Save</button>
                <button class='cancel'>Cancel</button>
                <button class='close' onclick="self.close()">X</button>
            </nav>
        </header>
        
        <script src="localization_editor.js?v=<?php echo uniqid(); ?>"></script>
    </body>
</html>