// ==========================================
//                Help/Manual
// ==========================================

function initializeHelp() { // used in: style functions, new post
// -------------------------------------------
// Initialize show help popup on element hoover
// -------------------------------------------
    // Create popup HTML if not exists
    if( $("#help_popup").length == 0 ) { $("body").append("<div id='help_popup'><p>Help</p></div>"); };
    $activeElements = $("button, label, .help, .manual");
    $activeElements.unbind("mouseenter").unbind("mouseleave");
    $activeElements.click( function() { $("#help_popup").hide(); });
    // ====== Deactivate help popup on touch screen ======
    $activeElements.on("touchstart", function() { $activeElements.unbind("mouseenter"); });
    // ====== MouseEnter ======
    $activeElements.on("mouseenter", function() {
        marg = 3; // popup margin in px
        $button = $(this);
        // ====== MouseLeave  ======
        $button.on("mouseleave", function() {
            $("#help_popup").stop().fadeOut(100, function() {
                $("#help_popup").attr("style", "");
            });
        });
        $("#touch_mouseleave").click(function() {
            $("#help_popup").stop().fadeOut(100, function() {
                $("#help_popup").attr("style", "");
            });
        });
        $("#help_popup").hide(0, function() { // hide previous if any

            //alert($("#help_popup").children().css("style"));

            help = $button.attr("help"); // Read help attribute
            if(help != undefined && help.trim() != "") {
                // Maual type help class
                if($button.attr("class").split(" ").indexOf("manual") > -1) {
                    $("#help_popup").addClass("black_bubble").removeClass("white_bubble");
                }
                // Standard type help class
                else {
                    $("#help_popup").removeClass("black_bubble").addClass("white_bubble");
                };
                // ====== Set popup position & direction ======
                xy = $button.offset();
                win_top = $("body").scrollTop();
                win_bot = win_top + $(window).height();
                // Fixed buttons div position
                if($button.closest("div").length && $button.closest("div").css("position") == "fixed") {
                    margin_top = parseInt($button.css("margin-top")) + parseInt($button.closest("div").css("margin-top")) + parseInt($button.closest("div").css("padding-top")) + parseInt($button.closest("div").css("top"));
                    if(margin_top > ($(window).height() / 2)) { dir = "up"; } else { dir = "down"; };
                }
                // Standard position
                else {
                   if(parseInt( xy.top ) - win_top > (win_bot - parseInt( xy.top )) * 3) { dir = "up"; } else { dir = "down"; }; // 3/1
                };
                wid = $button.width() + parseInt( $button.css("padding-left") ) * 2;
                hei = $button.height() + parseInt( $button.css("padding-top") ) * 2;
                if( $button.parent("div").attr("id") == "style_buttons" ) { dir = "up"; }; // Force help up to not cover the textarea
                 // Popup over button
                if( dir == "up" && parseInt(xy.left) > ($(window).width() / 2) ) { // popun on the left
                    //alert("up left");
                    $("#help_popup").css({
                        "top": "inherit", "bottom": $(window).height() - xy.top + marg * 1.5,
                        "left": "inherit", "right": $(window).width() - xy.left + marg - (wid / 2),
                        "border-radius": "10px 10px 0 10px"
                    });
                }
                else if( dir == "up" && parseInt(xy.left) <= ($(window).width() / 2) ) { // popun on the right
                    //alert("up right");
                    $("#help_popup").css({
                        "top": "inherit", "bottom": $(window).height() - xy.top + marg * 1.5,
                        "left": xy.left + wid + marg - (wid / 2), "right": "inherit",
                        "border-radius": "10px 10px 10px 0" 
                    });
                }
                // Popup below button
                else if( dir == "down" &&  parseInt(xy.left) > ($(window).width() / 2) ) { // popun on the left
                    //alert("down left");
                    $("#help_popup").css({
                        "top": xy.top + hei + marg * 1.5, "bottom": "inherit", 
                        "left": "inherit", "right": $(window).width() - xy.left + marg - (wid / 2),
                        "border-radius": "10px 0 10px 10px"
                    });
                }
                else if( dir == "down" && parseInt(xy.left) <= ($(window).width() / 2) ) { // popun on the right
                    //alert("down right");
                    $("#help_popup").css({
                        "top": xy.top + hei + marg * 1.5, "bottom": "inherit",
                        "left": xy.left + wid + marg - (wid / 2), "right": "inherit",
                        "border-radius": "0 10px 10px 10px" 
                    });
                };
                // ====== Popup special styles ======
                help = help.replace(/<d>/gi, "<span class='small_info'>");
                help = help.replace(/<\/d>/gi, "</span>");
                // ====== Change popup text & show ======
                $("#help_popup").html(help).fadeIn(250);
            }
            else {
                $("#help_popup").stop().hide();
            };
        });
    });
};

// ==========================================
//                  Popups
// ==========================================

function showPopup(icon, text, buttons, input) {
// --------------------------------
// icons = <string>
// text = <string>
// buttons = <string> BUTTONS labels divided with comas
// input = optional: <boolean> show INPUT; or <string> input placeholder content
// --------------------------------
// Adds & show page fader & popup box
// --------------------------------
    $("#page_fader, #popup_container").remove();
    html = "<div id='page_fader'></div>";
    html = html + "<div id='popup_container'><div id='popup_box'>";
    html = html + "<h6><span class='" + icon + "'></span></h6>";
    html = html + "<p class='info'>" + text.replace(/\n/g, "<br>") + "</p>";
    if(input != undefined && typeof(input) == "object") {
        html = html + "<select>";
        for(i in input) {
            html = html + "<option>" + input[i] + "</option>";
        }
        html = html + "</select>";
    }
    else if(input != undefined && input != false) {
        if(jQuery.type(input) != "string") { input = ""; };
        html = html + "<input type='text' placeholder='" + input + "'>";
    };
    // Buttons
    buttons = buttons.split(",");
    if(buttons.length == 2) {
        html = html + "<div class='buttons two'><button class='confirm'>" + buttons[0] + "</button><button class='cancel'>" + buttons[1] + "</button></div>";
    }
    else {
        html = html + "<div class='buttons one'><button class='confirm'>" + buttons[0] + "</button></div>";
    };
    // End
    html = html + "</div></div>"; // close popup box & container
    $("body").append( html ).css({ "overflow-y": "hidden" });

    $("#page_fader").stop().fadeIn(500);
    $("#popup_container").fadeIn(250, function() {
        // Focus on firt input
        if( $("#popup_container input").length ) { $("#popup_container input").first().focus(); };
        // Enter for confirm
        $("#popup_box input").on('keypress', function (e) {
            if(e.which == 13) {
                $(this).closest("#popup_box").find("button.confirm").trigger( "click" );
            };
        });
        // ESC key
        $(document).unbind("keyup").keyup(function(e) { if (e.keyCode === 27) { hidePopup(); }; });
    });
};

function infoPopup(text, icon) {
// --------------------------------
// text = <string> mesage text
// icon = <string> icon type
// --------------------------------
// Show custom vanishing alert box
// --------------------------------
    // icon
    color = false;
    if(icon == "done") { icon = "fi-checkbox"; color = "color_done"; }
    else if(icon == "error") { icon = "fi-x"; color = "color_error"; }
    else if(icon == "alert") { icon = "fi-alert"; }
    else if(jQuery.type(icon) != "string" || icon.substr(0, 3) != "fi-") { icon = "fi-lightbulb"; };
    // show popup
    $("#info_box").remove();
    html = "<div id='info_box'>";
    html = html + "<h6><span class='" + icon + "'></span></h6>";
    html = html + "<p class='info'>" + text.replace(/\n/g, "<br>") + "</p>";
    html = html + "</div>"; // close popup box & container
    $("body").append( html );
    //if(color != false) { $("#info_box h6").css({ "background-color": color }); };
    if(color != false) { $("#info_box h6").addClass(color); };
    $("#info_box").fadeIn(250).delay(2000).fadeOut(1500, function() {$(this).remove(); });
};

function hidePopup() {
// --------------------------------
// Hide & remove page fader & popup box
// --------------------------------
    $("#page_fader, #popup_container").fadeOut(250, function() { $(this).remove(); });
    $("body").css({ "overflow-y": "scroll" });
};
